import scriptHandler, globalPluginHandler, ui
import os, sys, re, json
path = os.path.dirname(__file__)
sys.path.append(path)
from selenium import webdriver

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
  scriptCategory = "新書快報"
  @scriptHandler.script(description = "新書快報", gesture = "kb:NVDA+\\")
  def script_nb(self, gesture):
    ui.message("連線中請稍候")
    browser = webdriver.Edge(path+r"\msedgedriver.exe")
    text = "<h1>國立臺灣圖書館視障資料中心</h1>"
    browser.get("http://viis.ntl.edu.tw/newbooks")
    content = browser.find_element_by_class_name("newbooklist").text
    text += "<ul>" + re.sub("\n(\\d)", "<li>\\1", content) + "</ul>"
    text += "<h1>華文視障電子圖書網</h1>"
    browser.get("http://books.batol.net/newbooks.php")
    content = browser.find_elements_by_tag_name("table")
    text += "<ol>" + content[8].text.replace("\n","<li>") + "</ol>"
    text += "<h1>彰化師大圖書與資訊處視覺障礙資料小組有聲書</h1>"
    browser.get("http://visual.ncue.edu.tw/")
    browser.find_element_by_partial_link_text("月上架").click()
    content = browser.find_element_by_class_name("news").text
    content = "<ol>" + content + "</ol>"
    content = content.replace("書目編號", "<li>書目編號")
    content = content.replace("書訊", "<</li>")
    text += content
    text += "<h1>雲端千眼</h1>"
    browser.get("https://www.edocumentservice.org/ebookSystem/api/bookinfos?newest=10")
    content = browser.find_elements_by_tag_name("pre")[1].text
    content = content[content.index("{"):content.index("]")]
    content = content.replace("},\n    {", "}_-_{")
    content = content.split("_-_")
    text += "<ol>"
    for i in content:
      t = json.loads(i)
      text += f'<li>{t["bookname"]} {t["author"]} {t["house"]} {t["date"]}'
    text += "</ol>"
    browser.close()
    browser.quit()
    ui.browseableMessage(text, "新書快報", True)
